// chocobot.d --- Post regular kwehs to Mastodon

// Copyright  © 2018 Jordi Gutiérrez Hermoso <jordigh@octave.org>

// Author: Jordi Gutiérrez Hermoso

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 3
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.


import std.stdio;
import std.net.curl;
import std.random: dice, uniform;
import core.thread : Thread;
import std.datetime: dur;
import std.string: chomp;

auto kweh() {
  static squawks = ["Kweh", "Kweh!?", "Kwehhh!?",  "K-KWEHHH!!!", "Whark!"];
  return squawks[dice(40, 4, 3, 2, 1)]; // Roll weighted dice
}

void sleep() {
  Thread.sleep(dur!"minutes"(uniform(40,80))); // Randomly sleep between 40-80 minutes
}

void send(string squawk) {
  auto token = File("chocotoken").readln.chomp;

  auto http = HTTP();
  http.addRequestHeader("Authorization", "Bearer " ~ token);
  try {
    writeln(post("https://botsin.space/api/v1/statuses", ["status": squawk], http));
  }
  catch (CurlException e) {
    writeln(e.msg);
  }
}

void main(string[] args) {
  while(true) {
    kweh.send; // Sugar for send(kweh), called Uniform Function Call Syntax (UFCS)
    sleep();
  }
}
